3 # git-submodules.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
13 or: $dashless [--quiet] foreach [--recursive] <command>
14 or: $dashless [--quiet] sync [--] [<path>...]"
33 # Resolve relative url by appending to parent's url
34 resolve_relative_url ()
36 remote=$(get_default_remote)
37 remoteurl=$(git config "remote.$remote.url") ||
38 die "$(eval_gettext "remote (\$remote) does not have a url defined in .git/config")"
40 remoteurl=${remoteurl%/}
49 remoteurl="${remoteurl%/*}"
52 remoteurl="${remoteurl%:*}"
56 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
67 echo "$remoteurl$sep${url%/}"
71 # Get submodule info for registered submodules
72 # $@ = path to limit submodule list
76 git ls-files --error-unmatch --stage -- "$@" |
79 my ($null_sha1) = ("0" x 40);
82 my ($mode, $sha1, $stage, $path) =
83 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
84 next unless $mode eq "160000";
86 if (!$unmerged{$path}++) {
87 print "$mode $null_sha1 U\t$path\n";
97 # Map submodule path to submodule name
103 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
104 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
105 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
106 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
108 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$path'")"
115 # Prior to calling, cmd_update checks that a possibly existing
116 # path is not a git repository.
117 # Likewise, cmd_add checks that path does not exist at all,
118 # since it is the location of a new submodule.
126 if test -n "$reference"
128 git-clone "$reference" -n "$url" "$path"
130 git-clone -n "$url" "$path"
132 die "$(eval_gettext "Clone of '\$url' into submodule path '\$path' failed")"
136 # Add a new submodule to the working tree, .gitmodules and the index
140 # optional branch is stored in global branch variable
144 # parse $args after "submodule ... add".
149 case "$2" in '') usage ;; esac
160 case "$2" in '') usage ;; esac
161 reference="--reference=$2"
185 if test -z "$path"; then
186 path=$(echo "$repo" |
187 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
190 if test -z "$repo" -o -z "$path"; then
194 # assure repo is absolute or relative to parent
197 # dereference source url relative to parent's url
198 realrepo=$(resolve_relative_url "$repo") || exit
205 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
210 # multiple //; leading ./; /./; /../; trailing /
211 path=$(printf '%s/\n' "$path" |
221 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
222 die "$(eval_gettext "'\$path' already exists in the index")"
224 if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
227 eval_gettext "The following path is ignored by one of your .gitignore files:
229 Use -f if you really want to add it." &&
235 # perhaps the path exists and is already a git repo, else clone it
238 if test -d "$path"/.git -o -f "$path"/.git
240 eval_gettext "Adding existing repo at '\$path' to the index"; echo
242 die "$(eval_gettext "'\$path' already exists and is not a valid git repo")"
247 url=$(resolve_relative_url "$repo") || exit
253 git config submodule."$path".url "$url"
256 module_clone "$path" "$realrepo" "$reference" || exit
260 # ash fails to wordsplit ${branch:+-b "$branch"...}
262 '') git checkout -f -q ;;
263 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
265 ) || die "$(eval_gettext "Unable to checkout submodule '\$path'")"
268 git add $force "$path" ||
269 die "$(eval_gettext "Failed to add submodule '\$path'")"
271 git config -f .gitmodules submodule."$path".path "$path" &&
272 git config -f .gitmodules submodule."$path".url "$repo" &&
273 git add --force .gitmodules ||
274 die "$(eval_gettext "Failed to register submodule '\$path'")"
278 # Execute an arbitrary command sequence in each checked out
281 # $@ = command to execute
285 # parse $args after "submodule ... foreach".
308 while read mode sha1 stage path
310 if test -e "$path"/.git
312 say "$(eval_gettext "Entering '\$prefix\$path'")"
313 name=$(module_name "$path")
315 prefix="$prefix$path/"
319 if test -n "$recursive"
321 cmd_foreach "--recursive" "$@"
324 die "$(eval_gettext "Stopping at '\$path'; script returned non-zero status.")"
330 # Register submodules in .git/config
332 # $@ = requested paths (default to all)
336 # parse $args after "submodule ... init".
358 while read mode sha1 stage path
360 # Skip already registered paths
361 name=$(module_name "$path") || exit
362 url=$(git config submodule."$name".url)
363 test -z "$url" || continue
365 url=$(git config -f .gitmodules submodule."$name".url)
367 die "$(eval_gettext "No url found for submodule path '\$path' in .gitmodules")"
369 # Possibly a url relative to parent
372 url=$(resolve_relative_url "$url") || exit
376 git config submodule."$name".url "$url" ||
377 die "$(eval_gettext "Failed to register url for submodule path '\$path'")"
379 upd="$(git config -f .gitmodules submodule."$name".update)"
381 git config submodule."$name".update "$upd" ||
382 die "$(eval_gettext "Failed to register update mode for submodule path '\$path'")"
384 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$path'")"
389 # Update each submodule path to correct revision, using clone and checkout as needed
391 # $@ = requested paths (default to all)
395 # parse $args after "submodule ... update".
416 case "$2" in '') usage ;; esac
417 reference="--reference=$2"
418 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
441 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
447 cmd_init "--" "$@" || return
452 while read mode sha1 stage path
456 echo >&2 "Skipping unmerged submodule $path"
459 name=$(module_name "$path") || exit
460 url=$(git config submodule."$name".url)
461 update_module=$(git config submodule."$name".update)
464 # Only mention uninitialized submodules when its
465 # path have been specified
467 say "$(eval_gettext "Submodule path '\$path' not initialized
468 Maybe you want to use 'update --init'?")"
472 if ! test -d "$path"/.git -o -f "$path"/.git
474 module_clone "$path" "$url" "$reference"|| exit
475 cloned_modules="$cloned_modules;$name"
478 subsha1=$(clear_local_git_env; cd "$path" &&
479 git rev-parse --verify HEAD) ||
480 die "$(eval_gettext "Unable to find current revision in submodule path '\$path'")"
483 if ! test -z "$update"
485 update_module=$update
488 if test "$subsha1" != "$sha1"
491 # If we don't already have a -f flag and the submodule has never been checked out
492 if test -z "$subsha1" -a -z "$force"
497 if test -z "$nofetch"
499 # Run fetch only if $sha1 isn't present or it
500 # is not reachable from a ref.
501 (clear_local_git_env; cd "$path" &&
502 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
503 test -z "$rev") || git-fetch)) ||
504 die "$(eval_gettext "Unable to fetch in submodule path '\$path'")"
507 # Is this something we just cloned?
508 case ";$cloned_modules;" in
510 # then there is no local change to integrate
514 case "$update_module" in
517 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$path'")"
518 say_msg="$(eval_gettext "Submodule path '\$path': rebased into '\$sha1'")"
522 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$path'")"
523 say_msg="$(eval_gettext "Submodule path '\$path': merged in '\$sha1'")"
526 command="git checkout $subforce -q"
527 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$path'")"
528 say_msg="$(eval_gettext "Submodule path '\$path': checked out '\$sha1'")"
532 (clear_local_git_env; cd "$path" && $command "$sha1") || die $die_msg
536 if test -n "$recursive"
538 (clear_local_git_env; cd "$path" && eval cmd_update "$orig_flags") ||
539 die "$(eval_gettext "Failed to recurse into submodule path '\$path'")"
548 git describe "$2" 2>/dev/null ||
549 git describe --tags "$2" 2>/dev/null ||
550 git describe --contains "$2" 2>/dev/null ||
551 git describe --all --always "$2"
554 test -z "$revname" || revname=" ($revname)"
557 # Show commit summary for submodules in index or working tree
559 # If '--cached' is given, show summary between index and given commit,
560 # or between working tree and given commit
562 # $@ = [commit (default 'HEAD'),] requested paths (default all)
569 # parse $args after "submodule ... summary".
583 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
605 test $summary_limit = 0 && return
607 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
611 elif test -z "$1" -o "$1" = "HEAD"
613 # before the first commit: compare with an empty tree
614 head=$(git hash-object -w -t tree --stdin </dev/null)
615 test -z "$1" || shift
623 die "$(gettext -- "--cached cannot be used with --files")"
629 # Get modified modules cared by user
630 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
631 sane_egrep '^:([0-7]* )?160000' |
632 while read mod_src mod_dst sha1_src sha1_dst status name
634 # Always show modules deleted or type-changed (blob<->module)
635 test $status = D -o $status = T && echo "$name" && continue
636 # Also show added or modified modules which are checked out
637 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
642 test -z "$modules" && return
644 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
645 sane_egrep '^:([0-7]* )?160000' |
647 while read mod_src mod_dst sha1_src sha1_dst status name
649 if test -z "$cached" &&
650 test $sha1_dst = 0000000000000000000000000000000000000000
654 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
656 100644 | 100755 | 120000)
657 sha1_dst=$(git hash-object $name)
664 eval_gettext "unexpected mode \$mod_dst" &&
673 test $mod_src = 160000 &&
674 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
677 test $mod_dst = 160000 &&
678 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
682 case "$missing_src,$missing_dst" in
684 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_src")"
687 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_dst")"
690 errmsg="$(eval_gettext " Warn: \$name doesn't contain commits \$sha1_src and \$sha1_dst")"
695 if test $mod_src = 160000 -a $mod_dst = 160000
697 range="$sha1_src...$sha1_dst"
698 elif test $mod_src = 160000
704 GIT_DIR="$name/.git" \
705 git rev-list --first-parent $range -- | wc -l
707 total_commits=" ($(($total_commits + 0)))"
711 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
712 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
715 blob="$(gettext "blob")"
716 submodule="$(gettext "submodule")"
717 if test $mod_dst = 160000
719 echo "* $name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
721 echo "* $name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
724 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
728 # Don't give error msg for modification whose dst is not submodule
729 # i.e. deleted or changed to blob
730 test $mod_dst = 160000 && echo "$errmsg"
732 if test $mod_src = 160000 -a $mod_dst = 160000
735 test $summary_limit -gt 0 && limit="-$summary_limit"
736 GIT_DIR="$name/.git" \
737 git log $limit --pretty='format: %m %s' \
738 --first-parent $sha1_src...$sha1_dst
739 elif test $mod_dst = 160000
741 GIT_DIR="$name/.git" \
742 git log --pretty='format: > %s' -1 $sha1_dst
744 GIT_DIR="$name/.git" \
745 git log --pretty='format: < %s' -1 $sha1_src
751 if test -n "$for_status"; then
752 if [ -n "$files" ]; then
753 gettext "# Submodules changed but not updated:"; echo
755 gettext "# Submodule changes to be committed:"; echo
758 sed -e 's|^|# |' -e 's|^# $|#|'
764 # List all submodules, prefixed with:
765 # - submodule not initialized
766 # + different revision checked out
768 # If --cached was specified the revision in the index will be printed
769 # instead of the currently checked out revision.
771 # $@ = requested paths (default to all)
775 # parse $args after "submodule ... status".
800 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
805 while read mode sha1 stage path
807 name=$(module_name "$path") || exit
808 url=$(git config submodule."$name".url)
809 displaypath="$prefix$path"
812 say "U$sha1 $displaypath"
815 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
817 say "-$sha1 $displaypath"
820 set_name_rev "$path" "$sha1"
821 if git diff-files --ignore-submodules=dirty --quiet -- "$path"
823 say " $sha1 $displaypath$revname"
827 sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
828 set_name_rev "$path" "$sha1"
830 say "+$sha1 $displaypath$revname"
833 if test -n "$recursive"
836 prefix="$displaypath/"
839 eval cmd_status "$orig_args"
841 die "$(eval_gettext "Failed to recurse into submodule path '\$path'")"
846 # Sync remote urls for submodules
847 # This makes the value for remote.$remote.url match the value
848 # specified in .gitmodules.
873 while read mode sha1 stage path
875 name=$(module_name "$path")
876 url=$(git config -f .gitmodules --get submodule."$name".url)
878 # Possibly a url relative to parent
881 url=$(resolve_relative_url "$url") || exit
885 say "$(eval_gettext "Synchronizing submodule url for '\$name'")"
886 git config submodule."$name".url "$url"
888 if test -e "$path"/.git
893 remote=$(get_default_remote)
894 git config remote."$remote".url "$url"
900 # This loop parses the command line arguments to find the
901 # subcommand name to dispatch. Parsing of the subcommand specific
902 # options are primarily done by the subcommand implementations.
903 # Subcommand specific options such as --branch and --cached are
904 # parsed here as well, for backward compatibility.
906 while test $# != 0 && test -z "$command"
909 add | foreach | init | update | status | summary | sync)
939 # No command word defaults to "status"
940 test -n "$command" || command=status
942 # "-b branch" is accepted only by "add"
943 if test -n "$branch" && test "$command" != add
948 # "--cached" is accepted only by "status" and "summary"
949 if test -n "$cached" && test "$command" != status -a "$command" != summary